/*
******************************************************************************
File:     main.c
Info:     Generated by Atollic TrueSTUDIO(R) 8.0.0   2017-12-05

The MIT License (MIT)
Copyright (c) 2009-2017 Atollic AB

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

******************************************************************************
*/

#include "stm32l4xx.h"
#include "stm32l4xx_hal.h"
#include "system_clock.h"

#include "MyDisp.h"

int main(void)
{
  HAL_Init();
  SystemClock_Config();

  mydisp.begin();
  mydisp.clearDisplay(clrMedBlueGray);

  HDS hds;
  HBMP hbmp;
  hds  = mtds.GetDs();
  hbmp = mtds.CreateBitmap(80, 30, 16);
  mtds.SetDrawingSurface(hds, hbmp);
  mtds.SetBgColor(hds, clrWhite);
  mtds.SetFgColor(hds, clrBlack);
  mtds.Rectangle(hds, 0, 0, 100, 50);
  mtds.SetPen(hds, penSolid);
  mtds.SetFont(hds, hfntConsole);
  mtds.TextOut(hds, 20, 10, 5, "HELLO");
  mtds.ReleaseDs(hds);

  mydisp.createButton(0, hbmp, hbmp, 10, 110);
  mydisp.enableButton(0, true);
  mydisp.drawButton(0, BUTTON_UP);

  mydisp.setForeground(clrBlack);
  mydisp.setBackground(clrDkGreen);
  mydisp.setPen(penSolid);
  mydisp.setTransparency(false);

  mydisp.drawText((char*) "Hello PmodMTDS!", 50, 200);
  mydisp.drawText((char*) "This example shows how to use", 4, 160);
  mydisp.drawText((char*) "    the PmodMTDS With the    ", 4, 169);
  mydisp.drawText((char*) "       KAmeLeon board        ", 4, 178);

  char textBuffer[32];
  int touchCounter = 0;
  while (1)
  {
	  mydisp.checkTouch();
	  if (mydisp.isTouched(0)) {
		  sprintf(textBuffer, "Counter: %d", touchCounter++);
		  mydisp.drawText(textBuffer, 100, 120);
	  }
  }
}
